package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.RelOriDir;
import com.ejie.ab79.model.inspecciones.OrigenesInspeccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelEstInsDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class RelOriDirDaoImpl implements RelOriDirDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRELORIDIR", "IDORIGENINSPECCION",
			"IDDIRECCION", "INFORMETECNICO", "FECHAREGISTRO", "USUARIOREGISTRO", "FECHAULTMODIFICACION",
			"USUARIOULTMODIFICACION", "DESCRIPCIONCASTELLANOORIGEN", "DESCRIPCIONEUSKERAORIGEN",
			"DESCRIPCIONCASTELLANODIRECCION", "DESCRIPCIONEUSKERADIRECCION" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<RelOriDir> rwMap = new RowMapper<RelOriDir>() {
		public RelOriDir mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelOriDir relOriDir = new RelOriDir();
			relOriDir.setIdRelOriDir(resultSet.getLong("IDRELORIDIR"));
			OrigenesInspeccion origenInspeccion = new OrigenesInspeccion();
			origenInspeccion.setIdOrigenInspeccion(resultSet.getInt("IDORIGENINSPECCION"));
			origenInspeccion.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANOORIGEN"));
			origenInspeccion.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERAORIGEN"));
			relOriDir.setOrigenInspeccion(origenInspeccion);
			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANODIRECCION"));
			direccion.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERADIRECCION"));
			relOriDir.setDireccion(direccion);
			relOriDir.setInformeTecnico(resultSet.getInt("INFORMETECNICO"));
			relOriDir.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			relOriDir.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			relOriDir.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			relOriDir.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));
			return relOriDir;

		}
	};

	private RowMapper<RelOriDir> rwMapPK = new RowMapper<RelOriDir>() {
		public RelOriDir mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new RelOriDir(resultSet.getLong("IDRELORIDIR"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	/*
	 * private RowMapper<JerarquiaDto<RelOriDir>> rwMapJerarquia = new
	 * RowMapper<JerarquiaDto<RelOriDir>>() { public JerarquiaDto<RelOriDir>
	 * mapRow(ResultSet resultSet, int rowNum) throws SQLException {
	 * 
	 * RelOriDir relOriDir = new RelOriDir();
	 * relOriDir.setIdRelOriDir(resultSet.getLong("IDRELORIDIR"));
	 * relOriDir.setIdOrigenInspeccion(resultSet.getInt("IDORIGENINSPECCION"));
	 * relOriDir.setIdDireccion(resultSet.getInt("IDDIRECCION"));
	 * relOriDir.setInformeTecnico(resultSet.getInt("INFORMETECNICO"));
	 * relOriDir.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
	 * relOriDir.setFechaUltmodificacion(resultSet.getDate(
	 * "FECHAULTMODIFICACION"));
	 * relOriDir.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
	 * relOriDir.setUsuarioUltmodificacion(resultSet.getString(
	 * "USUARIOULTMODIFICACION"));
	 * 
	 * JerarquiaDto<RelOriDir> jerarquia = new JerarquiaDto<RelOriDir>();
	 * jerarquia.setModel(relOriDir);
	 * jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
	 * jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
	 * jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
	 * jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
	 * return jerarquia; } };
	 */

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Updates a single row in the RelOriDir table.
	 *
	 * @param relOriDir
	 *            RelOriDir
	 * @return RelOriDir
	 */
	public RelOriDir update(RelOriDir relOriDir) {

		String query = "UPDATE REL_ORI_DIR SET ID_ORIGEN_INSPECCION=?, ID_DIRECCION=?, INFORME_TECNICO=?, FECHA_REGISTRO=?, USUARIO_REGISTRO=?, FECHA_ULTMODIFICACION=?, USUARIO_ULTMODIFICACION=? WHERE ID_REL_ORI_DIR=?";
		this.jdbcTemplate.update(query, relOriDir.getOrigenInspeccion().getIdOrigenInspeccion(),
				relOriDir.getDireccion().getIdDireccion(), relOriDir.getInformeTecnico(), relOriDir.getFechaRegistro(),
				relOriDir.getUsuarioRegistro(), relOriDir.getFechaUltmodificacion(),
				relOriDir.getUsuarioUltmodificacion(), relOriDir.getIdRelOriDir());
		return relOriDir;
	}

	/**
	 * Finds a single row in the RelOriDir table.
	 *
	 * @param relOriDir
	 *            RelOriDir
	 * @return RelOriDir
	 */
	@Transactional(readOnly = true)
	public RelOriDir find(RelOriDir relOriDir) {
		String query = "SELECT t1.ID_REL_ORI_DIR IDRELORIDIR, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t2.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANOORIGEN, t2.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERAORIGEN, "
				+ " t1.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANODIRECCION,t3.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERADIRECCION,t1.INFORME_TECNICO INFORMETECNICO, "
				+ " t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION "
				+ " FROM REL_ORI_DIR t1, ORIGENES_INSPECCION t2, DIRECCIONES t3"
				+ " WHERE 1=1 AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION"
				+ " AND t1.ID_REL_ORI_DIR=? ";

		List<RelOriDir> relestinsList = this.jdbcTemplate.query(query, this.rwMap, relOriDir.getIdRelOriDir());
		return (RelOriDir) DataAccessUtils.uniqueResult(relestinsList);
	}

	@Override
	public RelOriDir findByOrigenDireccion(RelOriDir relOriDir) {
		String query = "SELECT t1.ID_REL_ORI_DIR IDRELORIDIR, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t2.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANOORIGEN, t2.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERAORIGEN, "
				+ " t1.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANODIRECCION,t3.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERADIRECCION,t1.INFORME_TECNICO INFORMETECNICO, "
				+ " t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION "
				+ " FROM REL_ORI_DIR t1, ORIGENES_INSPECCION t2, DIRECCIONES t3"
				+ " WHERE 1=1 AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION"
				+ " AND t2.ID_ORIGEN_INSPECCION = ? AND t3.ID_DIRECCION = ? ";

		List<RelOriDir> relestinsList = this.jdbcTemplate.query(query, this.rwMap,
				relOriDir.getOrigenInspeccion().getIdOrigenInspeccion(), relOriDir.getDireccion().getIdDireccion());
		return (RelOriDir) DataAccessUtils.uniqueResult(relestinsList);
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<RelOriDir> getMultiple(RelOriDir filterRelEstIns, TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterRelEstIns, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, RelOriDir.class, params,
				"ID_REL_ORI_DIR");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the RelEstIns table.
	 *
	 * @param relOriDir
	 *            RelOriDir
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<RelOriDir>
	 */
	@Transactional(readOnly = true)
	public List<RelOriDir> findAll(RelOriDir relOriDir, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_ORI_DIR IDRELORIDIR, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t2.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANOORIGEN, t2.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERAORIGEN, "
						+ "t1.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANODIRECCION,t3.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERADIRECCION,t1.INFORME_TECNICO INFORMETECNICO, "
						+ " t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append(" FROM REL_ORI_DIR t1, ORIGENES_INSPECCION t2, DIRECCIONES t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(relOriDir);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, RelOriDirDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<RelOriDir>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the RelOriDir table using like.
	 *
	 * @param relOriDir
	 *            RelOriDir
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelEstIns>
	 */
	@Transactional(readOnly = true)
	public List<RelOriDir> findAllLike(RelOriDir relOriDir, TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_ORI_DIR IDRELORIDIR, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t2.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANOORIGEN, t2.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERAORIGEN, "
						+ "t1.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANODIRECCION,t3.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERADIRECCION,t1.INFORME_TECNICO INFORMETECNICO, "
						+ " t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append(" FROM REL_ORI_DIR t1, ORIGENES_INSPECCION t2, DIRECCIONES t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relOriDir, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, RelOriDirDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<RelOriDir>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the RelOriDir table.
	 *
	 * @param relOriDir
	 *            RelOriDir
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(RelOriDir relOriDir) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM REL_ORI_DIR t1, ORIGENES_INSPECCION t2, DIRECCIONES t3");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(relOriDir);
		StringBuilder where = new StringBuilder(
				"  WHERE 1=1 AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the RelOriDir table using like.
	 *
	 * @param relOriDir
	 *            RelOriDir
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(RelOriDir relOriDir, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM REL_ORI_DIR t1, ORIGENES_INSPECCION t2, DIRECCIONES t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relOriDir, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelEstIns entity
	 *
	 * @param relOriDir
	 *            RelOriDir Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(RelOriDir relOriDir) {

		StringBuilder where = new StringBuilder(RelOriDirDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relOriDir != null) {

			if (relOriDir.getIdRelOriDir() != null) {
				where.append(" AND t1.ID_REL_ORI_DIR = ?");
				params.add(relOriDir.getIdRelOriDir());
			}

			if (relOriDir.getOrigenInspeccion() != null) {
				where.append(" AND t2.ID_ORIGEN_INSPECCION = ?");
				params.add(relOriDir.getOrigenInspeccion().getIdOrigenInspeccion());
			}

			if (relOriDir.getDireccion() != null) {
				where.append(" AND t3.ID_DIRECCION = ?");
				params.add(relOriDir.getDireccion().getIdDireccion());
			}

			if (relOriDir.getInformeTecnico() != null) {
				where.append(" AND t1.INFORME_TECNICO = ?");
				params.add(relOriDir.getInformeTecnico());
			}

			if (relOriDir.getFechaRegistro() != null) {
				where.append(" AND t1.FECHA_REGISTRO = ?");
				params.add(relOriDir.getFechaRegistro());
			}

			if (relOriDir.getUsuarioRegistro() != null) {
				where.append(" AND t1.USUARIO_REGISTRO = ?");
				params.add(relOriDir.getUsuarioRegistro());
			}

			if (relOriDir.getFechaUltmodificacion() != null) {
				where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
				params.add(relOriDir.getFechaUltmodificacion());
			}

			if (relOriDir.getUsuarioUltmodificacion() != null) {
				where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
				params.add(relOriDir.getUsuarioUltmodificacion());
			}

		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelOriDir entity
	 *
	 * @param relestins
	 *            RelOriDir Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(RelOriDir relOriDir, Boolean startsWith) {

		StringBuilder where = new StringBuilder(RelOriDirDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relOriDir != null) {

			if (relOriDir.getIdRelOriDir() != null) {
				where.append(" AND t1.ID_REL_ORI_DIR = ?");
				params.add(relOriDir.getIdRelOriDir());
			}

			if (relOriDir.getOrigenInspeccion() != null) {
				where.append(" AND t2.ID_ORIGEN_INSPECCION = ?");
				params.add(relOriDir.getOrigenInspeccion().getIdOrigenInspeccion());
			}

			if (relOriDir.getDireccion() != null) {
				where.append(" AND t3.ID_DIRECCION = ?");
				params.add(relOriDir.getDireccion().getIdDireccion());
			}

			if (relOriDir.getInformeTecnico() != null) {
				where.append(" AND t1.INFORME_TECNICO = ?");
				params.add(relOriDir.getInformeTecnico());
			}

			if (relOriDir.getFechaRegistro() != null) {
				where.append(" AND t1.FECHA_REGISTRO = ?");
				params.add(relOriDir.getFechaRegistro());
			}

			if (relOriDir.getUsuarioRegistro() != null) {
				where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE '\\'");
				if (startsWith) {
					params.add(relOriDir.getUsuarioRegistro().toUpperCase() + "%");
				} else {
					params.add("%" + relOriDir.getUsuarioRegistro().toUpperCase() + "%");
				}
			}

			if (relOriDir.getFechaUltmodificacion() != null) {
				where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
				params.add(relOriDir.getFechaUltmodificacion());
			}

			if (relOriDir.getUsuarioUltmodificacion() != null) {
				where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE '\\'");
				if (startsWith) {
					params.add(relOriDir.getUsuarioUltmodificacion().toUpperCase() + "%");
				} else {
					params.add("%" + relOriDir.getUsuarioUltmodificacion().toUpperCase() + "%");
				}
			}

		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	/**
	 * Reorder the data list of RelOriDir selected for rup_table
	 *
	 * @param relOriDir
	 *            RelOriDir
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposTercero>>
	 */
	@Override
	public List<TableRowDto<RelOriDir>> reorderSelection(RelOriDir relOriDir, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_ORI_DIR IDRELORIDIR,t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t2.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANOORIGEN, t2.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERAORIGEN, "
						+ "t1.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANODIRECCION,t3.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERADIRECCION,t1.INFORME_TECNICO INFORMETECNICO, "
						+ " t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append(" FROM REL_ORI_DIR t1, ORIGENES_INSPECCION t2, DIRECCIONES t3 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relOriDir, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION         = t3.ID_DIRECCION");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, RelOriDir.class,
				filterParamList, "ID_REL_ORI_DIR");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelOriDir>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
